﻿using System;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

public partial class DefaultByFullPostBack : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
            Map1.CurrentExtent = new RectangleShape(-123.22, 55.05, -76, 16.91);
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ShapeFileFeatureLayer shapeFileFeatureLayer = new ShapeFileFeatureLayer(MapPath("~/app_data/STATES.shp"));
            shapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(100, 212, 220, 184), GeoColor.FromArgb(255, 132, 132, 154), 1);
            shapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay layerOverlay = new LayerOverlay();
            layerOverlay.Layers.Add(shapeFileFeatureLayer);
            Map1.CustomOverlays.Add(layerOverlay);

            InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("MarkerOverlay");
            markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage("theme/default/img/marker_blue.gif", 21, 25);
            markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            markerOverlay.Features.Add("TrackMarker", new Feature(-123, 40));
            Map1.CustomOverlays.Add(markerOverlay);
        }
    }

    private void UpdateTrackShape()
    {
        InMemoryMarkerOverlay markerOverlay = (InMemoryMarkerOverlay)Map1.CustomOverlays["MarkerOverlay"];
        PointShape point = (PointShape)markerOverlay.Features["TrackMarker"].GetShape();
        PointShape newPoint = new PointShape(point.X + 0.5, point.Y);
        if (newPoint.X > -77)
        {
            newPoint.X = -123;
        }

        markerOverlay.Features["TrackMarker"] = new Feature(newPoint);
    }

    protected void Timer1_Tick(object sender, EventArgs e)
    {
        UpdateTrackShape();
    }
}
