﻿using System;
using System.Web.UI;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Collections.Generic;
public partial class DefaultByJavascript : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
            Map1.CurrentExtent = new RectangleShape(-123.22, 55.05, -76, 16.91);
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ShapeFileFeatureLayer shapeFileFeatureLayer = new ShapeFileFeatureLayer(MapPath("~/app_data/STATES.shp"));
            shapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(100, 212, 220, 184), GeoColor.FromArgb(255, 132, 132, 154), 1);
            shapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay layerOverlay = new LayerOverlay();
            layerOverlay.Layers.Add(shapeFileFeatureLayer);
            Map1.CustomOverlays.Add(layerOverlay);

            InMemoryFeatureLayer lineLayer = new InMemoryFeatureLayer();
            lineLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.LocalRoad1;
            lineLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LineShape lineShape = new LineShape();
            lineShape.Vertices.Add(new Vertex(-123, 40));
            lineShape.Vertices.Add(new Vertex(-123, 40));
            Feature lineFeature = new Feature(lineShape);
            ViewState["LineState"] = lineFeature;

            lineLayer.Open();
            lineLayer.InternalFeatures.Add("LineShape", lineFeature);
            lineLayer.Close();

            LayerOverlay lineOverlay = new LayerOverlay("Line", false, TileType.SingleTile);
            lineOverlay.Layers.Add("LineLayer", lineLayer);
            Map1.CustomOverlays.Add(lineOverlay);


            List<string> featureColumnNames = new List<string>();
            featureColumnNames.Add("Type");
            featureColumnNames.Add("Name");
            featureColumnNames.Add("Style");
            featureColumnNames.Add("Num");


            Dictionary<string, string> columnValues = new Dictionary<string, string>();
            columnValues.Add("Type", "Type"); // Stop Name
            columnValues.Add("Name", "Temp1");
            columnValues.Add("Style", "NoStyle");
            columnValues.Add("Num", "1001");
            
            InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("MarkerOverlay",featureColumnNames);

            InMemoryMarkerOverlay markerOverlay1 = new InMemoryMarkerOverlay("MarkerOverlay1", featureColumnNames);
            
            
            markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage("theme/default/img/marker_blue.gif", 21, 25, -10.5f, -25f);
            markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            markerOverlay1.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage("theme/default/img/marker_green.gif", 21, 25, -10.5f, -25f);
            markerOverlay1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            Feature featObj = new Feature(-123, 40);

            featObj.ColumnValues.Add("Type", "Type"); // Stop Name
            featObj.ColumnValues.Add("Name", "Temp1");
            featObj.ColumnValues.Add("Style", "NoStyle");
            featObj.ColumnValues.Add("Num", "1001");

            markerOverlay.Features.Add("TrackMarker", featObj);


            Feature featObj1 = new Feature(-124, 41);

            featObj1.ColumnValues.Add("Type", "Type"); // Stop Name
            featObj1.ColumnValues.Add("Name", "Temp1");
            featObj1.ColumnValues.Add("Style", "NoStyle");
            featObj1.ColumnValues.Add("Num", "1001");



            markerOverlay1.Features.Add("TrackMarker1", featObj1);

            markerOverlay.Features.Add("TrackMarker1", featObj1);

            Map1.CustomOverlays.Add(markerOverlay);
            Map1.CustomOverlays.Add(markerOverlay1);
        }
    }

    private void UpdateTrackShape()
    {
        InMemoryMarkerOverlay markerOverlay = (InMemoryMarkerOverlay)Map1.CustomOverlays["MarkerOverlay"];
        InMemoryMarkerOverlay markerOverlay1 = (InMemoryMarkerOverlay)Map1.CustomOverlays["MarkerOverlay1"];
        PointShape point = (PointShape)markerOverlay.Features["TrackMarker"].GetShape();
        PointShape newPoint = new PointShape(point.X + 0.25, point.Y);
        if (newPoint.X > -77)
        {
            newPoint.X = -123;
        }

        InMemoryFeatureLayer lineLayer = (InMemoryFeatureLayer)((LayerOverlay)Map1.CustomOverlays["Line"]).Layers["LineLayer"];
        Feature lineFeature = (Feature)ViewState["LineState"];
        LineShape lineShape = ((LineShape)lineFeature.GetShape());
        lineShape.Vertices.Add(new Vertex(newPoint));

        lineLayer.InternalFeatures.Clear();
        lineLayer.InternalFeatures.Add(new Feature(lineShape));

        ((LayerOverlay)Map1.CustomOverlays["Line"]).Redraw();

        markerOverlay.Features.Clear();

        //markerOverlay.Features["TrackMarker"] = new Feature(newPoint);

        Feature featObj = new Feature(newPoint);

        featObj.ColumnValues.Add("Type", "Type"); // Stop Name
        featObj.ColumnValues.Add("Name", "Temp1");
        featObj.ColumnValues.Add("Style", "NoStyle");
        featObj.ColumnValues.Add("Num", "1001");

        markerOverlay.Features.Add("TrackMarker", featObj);


        PointShape point1 = (PointShape)markerOverlay1.Features["TrackMarker1"].GetShape();
        PointShape newPoint1 = new PointShape(point1.X + 0.25, point1.Y);
        if (newPoint.X > -77)
        {
          newPoint.X = -123;
        }


        Feature featObj1 = new Feature(newPoint1);

        featObj1.ColumnValues.Add("Type", "Type"); // Stop Name
        featObj1.ColumnValues.Add("Name", "Temp1");
        featObj1.ColumnValues.Add("Style", "NoStyle");
        featObj1.ColumnValues.Add("Num", "1001");

        markerOverlay1.Features.Clear();

        markerOverlay1.Features.Add("TrackMarker1", featObj1);

        markerOverlay.Features.Add("TrackMarker1", featObj1);


        ScriptManager.RegisterStartupScript(this, this.GetType(), "UpdateMarker", "UpdateMarkers()", true);
    }

    protected void Timer1_Tick(object sender, EventArgs e)
    {
        UpdateTrackShape();
    }
}
